Android — Помогите срочно! Android. kladr-api


Содержание

kladr-api.ru не работает или есть другие проблемы с доступом?

Проверка текущего статуса Кладр API уже запущена (13.11.2020).

Счетчик времени непрерывной работы kladr-api.ru

Разместите счетчик времени непрерывной работы kladr-api.ru на вашем сайте. Данный счетчик отображает процентное отношение удачных проверок к общему количеству проверок.

Что делать, если kladr-api.ru недоступен?

Если Кладр API работает, но вы не можете получить доступ к странице, попробуйте одно из следующих решений:

Кэш браузера . Большинство браузеров использует кэширование страниц для сохранения часто запрашиваемых ресурсов на компьютере пользователя, что позволяет сократить потребление трафика и ускорить работу браузера. Чтобы получить актуальную версию страницы, игнорируя кэш, используйте комбинацию Ctrl + F5 .

Блокировка доступа к сайту . Если вы используете динамические IP-адреса при подключении к Интернету, возможно, доступ к сайту для вашего текущего IP-адреса ранее был заблокирован. Очистите файлы cookie и смените IP-адрес .

Антивирус и файрвол . Убедитесь, что антивирусные программы или файрвол установленные на ваш компьютер не блокируют доступ к kladr-api.ru.

DNS-кэш . DNS-кэш содержит в себе записи о сайтах, которые вы посещали. Если, например, сайт сменил свой IP-адрес, вы не сможете получить к нему доступ. Очистите DNS-кэш на вашем компьютере и повторите попытку.

Альтернативные службы DNS . DNS (Domain Name System) преобразует доменные имена в IP-адреса. Попробуйте использовать альтернативную службу DNS , отличную от вашего провайдера, например, OpenDNS или Google Public DNS.

Документация

Мы храним базу ФИАС в собственном формате, оптимизированным для быстрого поиска. Для бесперебойной работы используем несколько серверов в облаке Mail.ru.

Токен

После регистрации в личном кабинете вы увидете свой уникальный токен.

Платные сервера

Всегда необходимо указывать свой токен в параметре token.

Бесплатные сервера

Токен указывать необязательно.

Интеграция с сайтом

Документация о настройке плагина находится на его github странице.

По умолчанию плагин настроен на работу с бесплатным сервером. Для работы с платным сервером добавьте свой токен и укажите URL платного сервера следующим образом:

Подключение к серверу (API)

Доступ к API является публичным, без каких-либо ограничений. Бесплатные сервера предоставляются как есть, мы не гарантируем их работоспособность и скорость ответа. Бесплатный API отлично подходит, например, для тестирования сервиса, личного использования, домашних страниц. Доступ к платным серверам возможен только при указании вашего токена, который мы активируем после оплаты.

Параметры запроса

  • Адрес страницы для запроса к платным серверам:

Плагины

Для облегчнения интеграции разработаны плагины под разные плаформы. Скачать их можно бесплатно.

Как легко заполнить адрес без ошибок? Интеграция с сервисом kladr-api.ru


Опубликовано:
26 октября 2020 в 12:30

Довольно часто в организации приходится заполнять карточки организаций, контактных лиц или персон. И один из реквизитов, который должен быть заполнен – это почтовый или юридический адрес. От корректности и правильности заполнения адреса зависит, например, каким в итоге будет сформирован конверт для отправки корреспонденции в модуле Канцелярия.

Процесс заполнения адреса может быть довольно трудоемким. Дополнительно существует риск, что адрес будет внесен ошибочно в следствие человеческого фактора. Это обуславливается отсутствием централизованной базы адресов, вроде ФИАС или КЛАДР, в поставке DIRECTUM.

К счастью, в интернете существует довольно много сервисов, которые предоставляют возможность подбирать адрес по ключевым словам. Одним из таких является сервис kladr-api.ru . Он дает возможность производить поиск города, улицы, номера дома. Также сервис является бесплатным для некоммерческого использования.

Интересным, на мой взгляд, показалась возможность возвращать данные по введенному почтовому индексу. В частности, по индексу может быть однозначно определен город, область или край, а также район, к которому относится индекс. А дальше – больше. Можно получить список улиц, относящихся к полученному населенному пункту, а также список строений.

Рисунок 1 Выбор улицы

Все вышеописанное удалось оформить в простенький диалог. Пользователь вводит индекс и отправляет запрос на сервис. Ответ приходит в виде JSON объекта. Далее происходит разбор JSON и получение нужных нам данных, таких как регион, округ или район и город. Далее необходимо выбрать улицу. Важным будет замечание, что сервис позволяет выбрать только те улицы, которые закреплены за конкретным индексом. После указания улицы идет поиск номеров строений. В заключение остается ввести номер квартиры или офиса. На выходе мы получаем объект, который содержит все данные, необходимые для формирования строки адреса. Остается только чуть доработать под необходимую пользователю логику, например, подстановку в реквизит.

Рисунок 2 Выбор номера строения

Бесплатная версия сервиса имеет ограничение – 100000 запросов в день. Разработчики объясняют это заботой о производительности системы. Помимо этого, в ходе работы над диалогом я выяснил, что в запросе возвращается не более 400 строк. Поэтому список номеров строений может быть не полным. В этом случае пользователь может ввести номер строения самостоятельно.

Рисунок 3 Результат работы.

Все, что показано на рисунках, оформлено в пакет разработки, который прикреплен к статье. Можно свободно использовать его в своих системах с учетом ограничений, указанных на на этой странице .

Android — Помогите срочно! Android. kladr-api

В: Market исчез из списка установленных программ

В: Как запретить Маркету самообновляться?

Для всех версий: Использовать ® LuckyPatcher by ChelpuS, в нем есть возможность отключить автообновление Google Play.

Указанные ниже способы работают на версии Маркета 2.x
О1: Удалить MarketUpdater.apk. Требуются root-привилегии. Если не удается удалить, можно заморозить с помощью ® Titanium Backup
О2: (спасибо пользователю kirill0605)

Делал даунгрейд маркета с 3* на 2.* по инструкции в шапке:
Работают оба варианта (в любом случае рут необходим) (на двух SGS попробовал):
1: «Удалить MarketUpdater.apk.» с помощью root explorer или аналога
2: «через приложение root explorer заходим: system-apk-marketUpdater», включаем режим r/w, «(жмем и держим) — разрешения — оставляем одну галочку в верхнем левом углу — только права на чтение для пользователя (r— / — / —) — оК.»

Если до указанных манипуляций, маркет успел обновиться, то заходим «Настройки/Приложения/Управление приложениями/», там находим маркет (в зависимости от прошивки он будет в разделе «Сторонний» и/или «все» и делаем по очереди:
1. Принудительно остановить
2. Очистить кэш
3. Удаление данных
4. Удаление обновления

После чего словил ошибку «Старая версия su»
Решается так:
заходим «Настройки/Приложения/Управление приложениями/» там находим «Суперпользователь» / «Superuser» (в зависимости от прошивки он будет в разделе «Сторонний» и/или «все» и делаем по очереди:
1. Принудительно остановить
2. Очистить кэш
3. Удаление данных
4. Удаление обновления

В: Установил кастомную прошивку, а в ней нет маркета / Установил кастомную прошивку и маркет с сайта, но он не работает. Что делать?

В: Новый Маркет ужасно тормозит, что делать?

В: Что делать, если интернет есть, а Маркет либо не запускается, либо не качает, либо выглядит «как-то не так».

В: Если Google Play перестал работать после Freedom

О1: Необходимо проверить установленное в системе дату и время. Проблема возникает из-за несоответствия времени на устройстве с временем действия сертификатов Google (срок еще не наступил или уже закончился). Необходимо выставить правильный часовой пояс, дату и время.
О2:
Такая ошибка довольно часто возникает из-за некорректной работы DNS серверов провайдеров. Для изменения DNS сервера на девайсе можно установить ® Set DNS и выбрать в настройках GoogleDNS (в PRO версии root права не нужны, она также есть в указанной теме в разделе Скачать). Если выход в интернет осуществляется через WI-FI, то в настройках роутера укажите в качестве DNS сервера — 8.8.8.8
О3:
Проверить файл /etc/hosts, в нем должна быть только одна строка — 127.0.0.1 localhost. Если строк больше — удалить все остальные, сохранить и проверить работу маркета. Необходимы root права, сделать можно с помощью ® Root Explorer.
О4:
Попробуйте поменять способ подключения к интернету wi-fi 3G, а также использовать другие точки подключения. Довольно часто эта проблема возникает из-за неполадок в сети.
О5:
1. Выполните хард-резет (общий сброс) смартфона. При этом все данные с него удалятся, но станет возможным подключить аккаунт Google;
2. Установите программу Add Account для принудительного добавления аккаунта в систему, сделать это можно следующим образом:

— cкачайте программу Add Account по ссылке ниже;
— запишите apk-файл в корень карты памяти;
— откройте стандартный браузер и введите следующее: content://com.android.htmlfileprovider/sdcard/add_account.apk
— перейдите по ссылке — начнется установка программы;

3. Запустите программу Add Account и введите Ваш адрес gmail в поле Account;
4. Нажмите Add Account;
5. Теперь при попытке синхронизации с аккаунтом Google возникнет ошибка с сообщением о том, что Вы неправильно ввели пароль. Достаточно просто нажать на уведомление и ввести пароль, после чего синхронизация с аккаунтом будет работать.
Скачать программу
О6:
(спасибо пользователю igrikmc)
1. качаем GApps (см. спойлер -> полезные файлы)
2. грузимся в Recovery (должен быть установлен CWR)
3. Выбираем «install zip from sdcard» -> «chose zip from sdcad» -список файлов->выбираем скаченный файл *.zip. подтверждаем «Yes — install *update*.zip»
4. reboot system now
при первой же загрузке предложит добавить учетную запись, добавление проходит без проблем.
З.Ы. Если уже были установлены некоторые гугловские приложения и они вдруг перестали работать, то просто нужно их переустановить.
О7: Google Play — Технические проблемы (Пост #20472955) (развернутый ответ по изменению файла hosts от vitobars)
О8: Google Play — Технические проблемы (Пост #21909029)

В: Вход не выполнен не удалось связаться с серверами Google

В: Нет соединения с Маркетом, ошибка «подключение отсутствует» / «Время ожидания подключения истекло»

В: Как бороться с ошибкой «Неожиданная остановка процесса com.android.vending»?

В: Маркет просит добавить аккаунт Exchange на устройство

В: При входе в Google Play возникает ошибка: «Ошибка Сервера»


В: Появляется сообщение об ошибке: процесс com.google.process.gapps остановлен.

В: Ошибка при получении данных с сервера [RH-01]

В: В процессе установки неизвестная ошибка: (24)

В: В процессе установки неизвестная ошибка: (25\26)

В: Не удается загрузить/обновить приложение «Название приложения» из-за ошибки (101)

В: Неизвестный код ошибки во время установки приложения (-110)

В: Не удалось загрузить/обновить приложение из-за ошибки (194)

В: Не удалось скачать приложение. Повторите попытку. Если проблема не исчезнет, попробуйте устранить ее самостоятельно. Код ошибки: (0)

В: Не удалось загрузить/обновить приложение из-за ошибки (403)

В: Не удалось загрузить/обновить приложение из-за ошибки (406)

В: Не удалось загрузить/обновить приложение из-за ошибки (489)

В: Не удается загрузить/обновить приложение «Название приложения» из-за ошибки (491)

В: Не удается загрузить/обновить приложение «Название приложения» из-за ошибки (492)

О1: Данная ошибка обычно связана с проблемами в разделе, предназначенном под кэш google play. Можно воспользоваться приложением Сache Fixer для очистки/увеличения (переноса) кэша на sd карту (кэш переносится до следующей перезагрузки устройства, после перезагрузки кэш опять будет в памяти телефона). tk.rede.cacheFixer-1.apk ( 136,6 КБ )
Для переноса кэша на постоянной основе можно воспользоваться утилитой MarketFix marketfix.apk ( 15,69 КБ )

Это значит, что отсутствует доступ к разделу cache, из-за чего приложение не может скачаться/обновиться из Маркета.

Решение: Скачиваем и устанавливаем эмулятор терминала (требуются права root).
В эмуляторе набираем следующее:
su
ls -la /cache
Смотрим, выдаст что-то типа этого:
drwxrwx— 1 1000 2001 2048 Jul 8 11:39 .
drwxr-xr-x 14 0 0 0 Jul 8 11:39 ..
drwxrwx—x 1 1000 1000 2048 Jul 7 13:12 dalvik-cache
lrwxrwxrwx 1 0 0 23 Jul 8 11:39 download -> /sdcard/dow nload-market
drwxrwx— 1 0 0 2048 Jul 7 13:12 lost+found

Набираем chmod 777 /cache -R
Проверяем ls -la /cache

Должно быть что-то типа этого:
drwxrwxrwx 1 1000 2001 2048 Jul 8 11:39 .
drwxr-xr-x 14 0 0 0 Jul 8 11:39 ..
drwxrwxrwx 1 1000 1000 2048 Jul 7 13:12 dalvik-cache
lrwxrwxrwx 1 0 0 23 Jul 8 11:39 download -> /sdcard/download-market
drwxrwxrwx 1 0 0 2048 Jul 7 13:12 lost+found

Как видите, права полностью восстановились и с Маркета качает :happy:

О3: Еще одно решение от пользователя Spectrall

Провел ряд экспериментов на своем планшете. Делюсь информацией.

При установке приложения с Маркета в папке cache появляется файл downloadfile.apk.

Ранее предполагалось, что ошибка 492 может возникать из-за отсутстия прав на изменение/удаление этого файла, либо на запись в другие папки, находящиеся внутри cache (у меня там расположены lost+found с правами rwxrwx— и recovery с rwxrwxrwx).

Поверив на слово автору этого поста, я создал у себя в cache недостающие папки dalvik-cache и download, а также закинул в нее левый файл с названием downloadfile.apk. Получил следующее дерево:

/cache/
-dalvik-cache/
-download/
-lost+found/
-recovery/
-downloadfile.apk

Затем у всех объектов внутри cache забрал права (выставил ———).

Далее очень удивился, поскольку после запуска Маркета файл downloadfile.apk и папки dalvik-cache и download просто исчезли, хотя у оставшихся lost+found и recovery права (точнее, их отсутствие) не изменились. Повторил эксперимент с уже запущенным Маркетом, непосредственно перед нажатием кнопки «Принять и загрузить» — результат оказался тем же.

Пробовал создавать другие объекты, помещать файлы большого размера — без толку, Маркет и их убивал молча и не задумываясь. Естественно, приложения скачивались, устанавливались, обновлялись. Кроме того, после перезагрузки аппарата две незатрагиваемые Маркетом папки (lost+found и recovery) как будто создавались заново: им возвращались первоначальные права. Естественно, перезагрузка также удаляла из cache весь мусор, который я туда помещал, абсолютно не напрягаясь по поводу наложенных запретов.

Единственным способом, заставившим Маркет капитулировать и выдать ошибку 492, стало снятие прав на запись с самой папки cache (я выставил на ней r—r—r—).

Думаю, дальше объяснять не нужно.

Могу лишь добавить, что не имею ни малейшего представления относительно того, как будут вести себя в подобных условиях другие аппараты и прошивки.


О4: И еще одно решение от пользователя typa.blade

В: Не удалось загрузить/обновить приложение из-за ошибки (498)

В: При попытке установить приложения возникает ошибка (499)

Загрузить КЛАДР — Заполнение полей доставки через API kladr-api
version: 1.0

Всем привет! В общем заказчику потребовалось подключить КЛАДР (классификатор адресов) и потратив силы и время вышел вот такой элемент (хотя можно и по частям его использовать).

Теперь о его работе:

Вам надо полючить токен на http://kladr-api.ru/ (бесплатно и до 200 000 обращений в сутки).
Далее вписать токен в JS файл, чуть ниже указать селекторы своих полей (улица + дом) и в самом конце укажите какой город нужен (675 строка примерно).

Если Вам не нужно указывать (проспект, улица и прочее) замените на 280 строке:

Про файлы и подключение:

kladrapi-js — основной API JS файл — лучше подключите в свой шаблон или же например в jbassets и тут подключите: По аналогии с shipping-type.js

Цукерберг рекомендует:  Javascript - Как сделать часы для сайта на javascript

kladr — extractme to root site — это элемент shipping-field — просто распакуйте и добавьте на страницу (лучше не выводить — будет просто в display:none).

joomla_options global — популярный плагин отключение mootools / jquery (глобально).
joomla_optionszoo — модифицированный плагин (отключает mootools только на странице корзины — basket).

СПОНСОР ( мешка макарон на месяц )

Финансовая поддержка:
Счастья, здоровья и конечно же уважение всем тем, кто может помочь рублем — мои данные на этой странице .

API reference

You can build your Android app with the Android Platform APIs and the following libraries.

Note: Many Kotlin reference topics are derived from Java-based source code. This means that some Kotlin reference topics might contain Java code snippets.

Android Support Library

Provides a variety of Android feature and utility APIs that are compatible with a wide range of platform versions.

AndroidX

Refactored versions of the Android APIs that are not bundled with the operating system.

AndroidX Test

Includes APIs for testing your Android app, including Espresso, JUnit Runner, JUnit4 rules, and UI Automator.

AndroidX Constraint Layout

Includes ConstraintLayout and related APIs for building constraint-based layouts.

Architecture Components

Includes APIs for a variety of core app components, such as APIs that manage your UI component lifecycle, data persistence, view model, and more.

Jetpack Compose

Jetpack Compose is a modern toolkit for building native Android UI. Jetpack Compose simplifies and accelerates UI development on Android with less code, powerful tools, and intuitive Kotlin APIs.

Android Automotive Library

Provides APIs for building Android Automotive apps.

Databinding Library


Includes APIs to help you write declarative layouts and minimize the glue code necessary to bind your application logic and layouts.

Material Components

Material Components for Android (MDC-Android) help developers execute Material Design to build beautiful and functional Android apps.

Constraint Layout Library

Legacy Support Library ConstraintLayout and related APIs for building constraint-based layouts.

Android Test Support Library

Includes APIs for testing your Android app, including Espresso, JUnit Runner, JUnit4 rules, and UI Automator.

Android Wearable Library

Provides APIs to build apps for wearable devices running Wear OS by Google.

Android Things Library

Provides APIs to build connected devices running the Android Things platform.

Play In-app Billing Library

Provides APIs to help you implement Google Play’s in-app billing and subscription features.

Play Core Library

Provides APIs to help you request, monitor, and manage on demand downloads for Google Play Instant and Dynamic Delivery.

Play Install Referrer library

Provides APIs to securely retrieve referral content from Google Play.

Content and code samples on this page are subject to the licenses described in the Content License. Java is a registered trademark of Oracle and/or its affiliates.

Общие сведения об уровнях API Android Understanding Android API levels

Xamarin. Android имеет несколько параметров уровня API Android, которые определяют совместимость приложения с несколькими версиями Android. В этом руководство объясняется, что означают эти параметры, как их настроить и как они влияют на приложение во время выполнения. Xamarin.Android has several Android API level settings that determine your app’s compatibility with multiple versions of Android. This guide explains what these settings mean, how to configure them, and what effect they have on your app at run time.

Быстрое начало работы Quick start

Xamarin. Android предоставляет три параметра проекта уровня API Android: Xamarin.Android exposes three Android API level project settings:

Целевая платформа – указывает, какая платформа будет использоваться при сборке приложения. Target Framework – Specifies which framework to use in building your application. Этот уровень API используется на этапе компиляции Xamarin. Android. This API level is used at compile time by Xamarin.Android.

Минимальная версия android – указывает самую раннюю версию Android, которую должно поддерживать ваше приложение. Minimum Android Version – Specifies the oldest Android version that you want your app to support. Этот уровень API используется Android во время выполнения . This API level is used at run time by Android.

Целевая версия android – указывает версию Android, на которой должно выполняться приложение. Target Android Version – Specifies the version of Android that your app is intended to run on. Этот уровень API используется Android во время выполнения . This API level is used at run time by Android.

Прежде чем можно будет настроить уровень API для проекта, необходимо установить компоненты платформы SDK для этого уровня API. Before you can configure an API level for your project, you must install the SDK platform components for that API level. Дополнительные сведения о загрузке и установке компонентов пакет SDK для Android см. в разделе пакет SDK для Android Setup. For more information about downloading and installing Android SDK components, see Android SDK Setup.

Начиная с августа 2020, консоль Google Play потребует, чтобы новые приложения были нацелены на уровень API 26 (Android 8,0) или более поздней версии. Beginning in August 2020, the Google Play Console will require that new apps target API level 26 (Android 8.0) or higher. Существующие приложения должны быть нацелены на уровень API 26 или выше, начиная с ноября 2020. Existing apps will be required to target API level 26 or higher beginning in November 2020. Дополнительные сведения см. в статье улучшение безопасности и производительности приложений на Google Play в течение года. For more information, see Improving app security and performance on Google Play for years to come.

Как правило, для всех трех уровней API Xamarin. Android задано одно и то же значение. Normally, all three Xamarin.Android API levels are set to the same value. На странице приложение задайте для параметра компилировать с помощью версии Android (Целевая платформа) последнюю стабильную версию API (или, как минимум, до версии Android, которая содержит все необходимые компоненты). On the Application page, set Compile using Android version (Target Framework) to the latest stable API version (or, at a minimum, to the Android version that has all of the features you need). На следующем снимке экрана для целевой платформы задано значение Android 7,1 (API уровня 25-Nougat) : In the following screenshot, the Target Framework is set to Android 7.1 (API Level 25 — Nougat):

На странице манифеста Android установите минимальную версию Android для использования компиляции с использованием версии пакета SDK и задайте для целевой версии Android то же значение, что и для целевой версии .NET Framework (на следующем снимке экрана Целевая платформа Android имеет значение Android 7,1 (Nougat) ): On the Android Manifest page, set the Minimum Android version to Use Compile using SDK version and set the Target Android version to the same value as the Target Framework version (in the following screenshot, the Target Android Framework is set to Android 7.1 (Nougat)):

Если вы хотите обеспечить обратную совместимость с более ранней версией Android, задайте для минимальной версии Android целевую версию Android, которая будет поддерживаться вашим приложением. If you want to maintain backward compatibility with an earlier version of Android, set Minimum Android version to target to the oldest version of Android that you want your app to support. (Обратите внимание, что уровень API 14 — это минимальный уровень API, необходимый для Google Play служб и поддержки Firebase.) В следующем примере конфигурация поддерживает версии Android из API уровня 14 через уровень API 25. (Note that API Level 14 is the minimum API level required for Google Play services and Firebase support.) The following example configuration supports Android versions from API Level 14 through API level 25:


Как правило, для всех трех уровней API Xamarin. Android задано одно и то же значение. Normally, all three Xamarin.Android API levels are set to the same value. Задайте для целевой платформы последнюю стабильную версию API (или, как минимум, до версии Android, которая содержит все необходимые компоненты). Set Target framework to the latest stable API version (or, at a minimum, to the Android version that has all of the features you need). Чтобы задать целевую платформу, перейдите к разделу Сборка > общие в параметрах проекта. To set the Target framework, navigate to Build > General in the Project Options. На следующем снимке экрана Целевая платформа настроена для использования последней установленной платформы (8,0) : In the following screenshot, the Target Framework is set to Use the latest installed platform (8.0):

Параметры минимальной и целевой версий Android можно найти в разделе сборка > приложение Android в параметрах проекта. The Minimum and Target Android version settings can be found under Build > Android Application in Project Options. Задайте минимальную версию Android для автоматического использования целевой версии .NET Framework и задайте в качестве целевой версии Android то же значение, что и у целевой версии .NET Framework. Set the Minimum Android version to Automatic — use target framework version and set the Target Android version to the same value as the Target Framework version. На следующем снимке экрана Целевая платформа Android настроена на android 8,0 (API уровня 26) в соответствии с параметром целевой платформы выше: In the following screenshot, the Target Android Framework is set to Android 8.0 (API level 26) to match the Target Framework setting above:

Если вы хотите обеспечить обратную совместимость с более ранней версией Android, измените минимальную версию Android на самую старую версию Android, которую должно поддерживать ваше приложение. If you want to maintain backward compatibility with an earlier version of Android, change Minimum Android version to the oldest version of Android that you want your app to support. Обратите внимание, что уровень API 14 — это минимальный уровень API, необходимый для Google Play служб и поддержки Firebase. Note that API Level 14 is the minimum API level required for Google Play services and Firebase support. Например, следующая конфигурация поддерживает версии Android как раньше, чем API уровня 14: For example, the following configuration supports Android versions as early as API Level 14:

Если приложение поддерживает несколько версий Android, в коде должны содержаться проверки среды выполнения, чтобы обеспечить работу приложения с минимальной версией Android (Дополнительные сведения см. в разделе проверки среды выполнения для версий Android ниже). If your app supports multiple Android versions, your code must include runtime checks to ensure that your app works with the Minimum Android version setting (see Runtime Checks for Android Versions below for details). Если вы используете или создаете библиотеку, ознакомьтесь со статьей уровни API и библиотеки ниже, чтобы получить рекомендации по настройке параметров уровня API для библиотек. If you are consuming or creating a library, see API Levels and Libraries below for best practices in configuring API level settings for libraries.

Версии Android и уровни API Android versions and API levels

По мере развития платформы Android и выпуска новых версий Android каждой версии Android назначается уникальный целочисленный идентификатор, называемый уровнем API. As the Android platform evolves and new Android versions are released, each Android version is assigned a unique integer identifier, called the API Level. Таким образом, каждая версия Android соответствует одному уровню API Android. Therefore, each Android version corresponds to a single Android API Level. Так как пользователи устанавливают приложения на более ранних версий, а также в самых последних версиях Android, приложения для работы в реальном времени для Android должны быть разработаны с несколькими уровнями API Android. Because users install apps on older as well as the most recent versions of Android, real-world Android apps must be designed to work with multiple Android API levels.

Версии Android Android versions

Каждый выпуск Android проходит несколько имен: Each release of Android goes by multiple names:

  • Версия Android, например android 9,0 The Android version, such as Android 9.0
  • Имя кода (или десерт), например круговая диаграмма A code (or dessert) name, such as Pie
  • Соответствующий уровень API, например уровень API 28 A corresponding API level, such as API level 28

Имя кода Android может соответствовать нескольким версиям и уровням API (как показано в таблице ниже), но каждая версия Android соответствует ровно одному уровню API. An Android code name may correspond to multiple versions and API levels (as seen in the table below), but each Android version corresponds to exactly one API level.

Кроме того, Xamarin. Android определяет коды версий сборки , которые сопоставляются с известными уровнями API Android. In addition, Xamarin.Android defines build version codes that map to the currently known Android API levels. Следующая таблица поможет вам выполнить преобразование между уровнем API, версией Android, кодовым именем и кодом версии сборки Xamarin. Android (коды версий сборки определяются в пространстве имен Android.OS ): The following table can help you translate between API level, Android version, code name, and Xamarin.Android build version code (build version codes are defined in the Android.OS namespace):

name Name Version Version Уровень API API Level Выпущено Released Код версии сборки Build Version Code
Круговая диаграмма Pie 9.0 9.0 28 28 Авг 2020 Aug 2020 BuildVersionCodes.P
Oreo Oreo 8.1 8.1 27 27 Dec 2020 Dec 2020 BuildVersionCodes.OMr1
Oreo Oreo 8.0 8.0 26 26 Авг 2020 Aug 2020 BuildVersionCodes.O
Nougat Nougat 7.1 7.1 25 25 Dec 2020 Dec 2020 BuildVersionCodes.NMr1
Nougat Nougat 7.0 7.0 24 24 Авг 2020 Aug 2020 BuildVersionCodes.N
Marshmallow Marshmallow 6.0 6.0 23 23 Авг 2015 Aug 2015 BuildVersionCodes.M
Интерфейса Lollipop 5.1 5.1 22 22 Мар 2015 Mar 2015 BuildVersionCodes.LollipopMr1
Интерфейса Lollipop 5.0 5.0 21 21 2014 ноября Nov 2014 BuildVersionCodes.Lollipop
KitKat Watch Kitkat Watch 4.4 W 4.4W 20 20 Июнь 2014 Jun 2014 BuildVersionCodes.KitKatWatch
KitKat Kitkat 4,4 4.4 19 19 Октябрь 2013 Oct 2013 BuildVersionCodes.KitKat
Jelly Bean Jelly Bean 4.3 4.3 18 18 Июл 2013 Jul 2013 BuildVersionCodes.JellyBeanMr2
Jelly Bean Jelly Bean 4.2 — 4.2.2 4.2-4.2.2 17 17 2012 ноября Nov 2012 BuildVersionCodes.JellyBeanMr1
Jelly Bean Jelly Bean 4.1 — 4.1.1 4.1-4.1.1 16 16 Июнь 2012 Jun 2012 BuildVersionCodes.JellyBean
Южные Сандвичевы Ice Cream Sandwich 4.0.3 — 4.0.4 4.0.3-4.0.4 15 15 Dec 2011 Dec 2011 BuildVersionCodes.IceCreamSandwichMr1
Южные Сандвичевы Ice Cream Sandwich 4.0 — 4.0.2 4.0-4.0.2 14 14 Октябрь 2011 Oct 2011 BuildVersionCodes.IceCreamSandwich
хонэйкомб Honeycomb 3,2 3.2 13 13 Июнь 2011 Jun 2011 BuildVersionCodes.HoneyCombMr2
хонэйкомб Honeycomb 3.1. x 3.1.x 12 12 Май 2011 May 2011 BuildVersionCodes.HoneyCombMr1
хонэйкомб Honeycomb 3.0. x 3.0.x 11 11 Фев 2011 Feb 2011 BuildVersionCodes.HoneyComb
Gingerbread Gingerbread 2.3.3 — 2.3.4 2.3.3-2.3.4 10 10 Фев 2011 Feb 2011 BuildVersionCodes.GingerBreadMr1
Gingerbread Gingerbread 2.3 — 2.3.2 2.3-2.3.2 9 9 2010 ноября Nov 2010 BuildVersionCodes.GingerBread
фройо Froyo 2.2. x 2.2.x 8 8 Июнь 2010 Jun 2010 BuildVersionCodes.Froyo
еклаир Eclair 2.1. x 2.1.x 7 7 янв 2010 Jan 2010 BuildVersionCodes.EclairMr1
еклаир Eclair 2.0.1 2.0.1 6 6 Dec 2009 Dec 2009 BuildVersionCodes.Eclair01
еклаир Eclair 2.0 2.0 5 5 2009 ноября Nov 2009 BuildVersionCodes.Eclair
Кольцо Donut 1.6 1.6 4 4 Sep 2009 Sep 2009 BuildVersionCodes.Donut
купкаке Cupcake 1.5 1.5 3 3 Май 2009 May 2009 BuildVersionCodes.Cupcake
Базовый Base 1.1 1.1 2 2 Фев 2009 Feb 2009 BuildVersionCodes.Base11
Базовый Base 1.0 1.0 1 1 Октябрь 2008 Oct 2008 BuildVersionCodes.Base

Как показано в этой таблице, новые версии Android часто выпускаются – иногда более чем на один выпуск в год. As this table indicates, new Android versions are released frequently – sometimes more than one release per year. В результате среда устройств Android, на которых может работать ваше приложение, включает в себя множество более старых и более новых версий Android. As a result, the universe of Android devices that might run your app includes of a wide variety of older and newer Android versions. Как вы можете гарантировать, что приложение будет выполняться единообразно и надежно на разных версиях Android? How can you guarantee that your app will run consistently and reliably on so many different versions of Android? Уровни API для Android могут помочь в управлении этой проблемой. Android’s API levels can help you manage this problem.

Уровни API Android Android API levels

Каждое устройство Android выполняется на уровне API, – этот уровень API гарантированно уникален для каждой версии платформы Android. Each Android device runs at exactly one API level – this API level is guaranteed to be unique per Android platform version. Уровень API точно определяет версию набора API, к которому может обращаться приложение. Он определяет сочетание элементов манифеста, разрешений и т. д., которые вы задаете в качестве разработчика. The API level precisely identifies the version of the API set that your app can call into; it identifies the combination of manifest elements, permissions, etc. that you code against as a developer. Система Android на уровнях API позволяет Android определить, совместимо ли приложение с образом системы Android перед установкой приложения на устройстве. Android’s system of API levels helps Android determine whether an application is compatible with an Android system image prior to installing the application on a device.

При сборке приложения он содержит следующие сведения об уровне API: When an application is built, it contains the following API level information:

Целевой уровень API Android, на котором построено приложение для запуска. The target API level of Android that the app is built to run on.

Минимальный уровень API Android, который должен иметь устройство Android для запуска приложения. The minimum Android API level that an Android device must have to run your app.

Эти параметры используются, чтобы убедиться, что функции, необходимые для корректного запуска приложения, доступны на устройстве Android во время установки. These settings are used to ensure that the functionality needed to run the app correctly is available on the Android device at installation time. В противном случае приложение блокируется на этом устройстве. If not, the app is blocked from running on that device. Например, если уровень API устройства Android ниже минимального уровня API, указанного для приложения, устройство Android не позволит пользователю установить приложение. For example, if the API level of an Android device is lower than the minimum API level that you specify for your app, the Android device will prevent the user from installing your app.

Параметры уровня API проекта Project API level settings

В следующих разделах объясняется, как с помощью диспетчера пакетов SDK подготовить среду разработки для уровней API, которые вы хотите ориентировать, а затем подробно объяснить, как настроить целевую платформу, минимальную версию Androidи Параметры целевой версии Android в Xamarin. Android. The following sections explain how to use the SDK Manager to prepare your development environment for the API levels you want to target, followed by detailed explanations of how to configure Target Framework, Minimum Android version, and Target Android version settings in Xamarin.Android.

Платформы пакет SDK для Android Android SDK platforms

Прежде чем можно будет выбрать целевой или минимальный уровень API в Xamarin. Android, необходимо установить пакет SDK для Android версию платформы, соответствующую этому уровню API. Before you can select a Target or Minimum API level in Xamarin.Android, you must install the Android SDK platform version that corresponds to that API level. Диапазон доступных вариантов для целевой платформы, минимальной версии Android и целевой версии Android ограничен диапазоном установленных версий пакет SDK для Android. The range of available choices for Target Framework, Minimum Android version, and Target Android version is limited to the range of Android SDK versions that you have installed. С помощью диспетчера пакетов SDK можно проверить, установлены ли требуемые версии пакет SDK для Android, и можно использовать ее для добавления новых уровней API, необходимых для приложения. You can use the SDK Manager to verify that the required Android SDK versions are installed, and you can use it to add any new API levels that you need for your app. Если вы не знакомы с установкой уровней API, см. раздел пакет SDK для Android Setup. If you are not familiar with how to install API levels, see Android SDK Setup.

Требуемая версия .NET Framework Target Framework

Целевая платформа (также известная как compileSdkVersion ) — это конкретная версия платформы Android (уровень API), для которой компилируется приложение во время сборки. The Target Framework (also known as compileSdkVersion ) is the specific Android framework version (API level) that your app is compiled for at build time. Этот параметр указывает, какие API- интерфейсы будет использовать приложение при его запуске, но не влияет на то, какие API фактически доступны для приложения при его установке. This setting specifies what APIs your app expects to use when it runs, but it has no effect on which APIs are actually available to your app when it is installed. В результате изменение параметра целевой платформы не приводит к изменению поведения среды выполнения. As a result, changing the Target Framework setting does not change runtime behavior.

Целевая платформа определяет версии библиотек, с которыми связано приложение, – этот параметр определяет, какие интерфейсы API можно использовать в приложении. The Target Framework identifies which library versions your application is linked against – this setting determines which APIs you can use in your app. Например, если вы хотите использовать метод нотификатионбуилдер. сеткатегори , который появился в интерфейсе программирования Android 5,0, необходимо задать целевую платформу на уровне API 21 (без описания операций) или более поздней версии. For example, if you want to use the NotificationBuilder.SetCategory method that was introduced in Android 5.0 Lollipop, you must set the Target Framework to API Level 21 (Lollipop) or later. Если задать целевую платформу проекта на уровне API, например на уровне API 19 (KitKat) , и попытаться вызвать метод SetCategory в коде, возникнет ошибка компиляции. If you set your project’s Target Framework to an API level such as API Level 19 (KitKat) and try to call the SetCategory method in your code, you will get a compile error.

Рекомендуется всегда компилироваться с последней доступной версией целевой платформы. We recommend that you always compile with the latest available Target Framework version. Это позволяет получить полезные предупреждения для всех устаревших интерфейсов API, которые могут быть вызваны кодом. Doing so provides you with helpful warning messages for any deprecated APIs that might be called by your code. Использование последней версии целевой платформы особенно важно при использовании последних выпусков библиотеки поддержки – каждая библиотека предполагает, что приложение должно быть скомпилировано на основе минимального уровня API библиотеки поддержки или выше. Using the latest Target Framework version is especially important when you use the latest support library releases – each library expects your app to be compiled at that support library’s minimum API level or greater.

Чтобы получить доступ к параметру целевой платформы в Visual Studio, откройте свойства проекта в Обозреватель решений и выберите страницу приложения : To access the Target Framework setting in Visual Studio, open the project properties in Solution Explorer and select the Application page:

Задайте целевую платформу, выбрав уровень API в раскрывающемся меню в разделе компилировать с использованием версии Android , как показано выше. Set the Target Framework by selecting an API level in the drop-down menu under Compile using Android version as shown above.

Чтобы получить доступ к параметру целевой платформы в Visual Studio для Mac, щелкните правой кнопкой мыши имя проекта и выберите пункт Параметры. Откроется диалоговое окно Параметры проекта . To access the Target Framework setting in Visual Studio for Mac, right-click the project name and select Options; this opens the Project Options dialog. В этом диалоговом окне перейдите в раздел Build > General (общие ), как показано ниже: In this dialog, navigate to Build > General as shown here:


Задайте целевую платформу, выбрав уровень API в раскрывающемся меню справа от целевой платформы , как показано выше. Set the Target Framework by selecting an API level in the drop-down menu to the right of Target framework as shown above.

Минимальная версия Android Minimum Android Version

Минимальная версия Android (также известная как minSdkVersion ) — это самая старая версия ОС Android (то есть самый низкий уровень API), которая может установить и запустить приложение. The Minimum Android version (also known as minSdkVersion ) is the oldest version of the Android OS (i.e., the lowest API level) that can install and run your application. По умолчанию приложение может быть установлено только на устройствах, соответствующих параметру целевой платформы или выше. Если минимальная версия Android меньше, чем Целевая платформа, приложение также может работать в более ранних версиях Android. By default, an app can only be installed on devices matching the Target Framework setting or higher; if the Minimum Android version setting is lower than the Target Framework setting, your app can also run on earlier versions of Android. Например, если задать в качестве целевой платформы android 7,1 (Nougat) и установить для минимальной версии Android значение Android 4.0.3 (Ice-Южные Сандвичевы) , приложение можно установить на любой платформе с уровня API 15 на уровень API 25 включительно. For example, if you set the Target Framework to Android 7.1 (Nougat) and set the Minimum Android version to Android 4.0.3 (Ice Cream Sandwich), your app can be installed on any platform from API level 15 to API level 25, inclusive.

Несмотря на то, что приложение может успешно создаваться и устанавливаться на этом диапазоне платформ, это не гарантирует, что он будет успешно запущен на всех этих платформах. Although your app may successfully build and install on this range of platforms, this does not guarantee that it will successfully run on all of these platforms. Например, если приложение установлено в android 5,0 (без описания операций) и код вызывает API, доступный только в Android 7,1 (Nougat) и более поздней версии, приложение получит ошибку во время выполнения и, возможно, приведет к сбою. For example, if your app is installed on Android 5.0 (Lollipop) and your code calls an API that is available only in Android 7.1 (Nougat) and newer, your app will get a runtime error and possibly crash. Поэтому код должен обеспечить – во время выполнения –, что он вызывает только те интерфейсы API, которые поддерживаются устройством Android, на котором оно выполняется. Therefore, your code must ensure – at runtime – that it calls only those APIs that are supported by the Android device that it is running on. Иными словами, код должен включать явные проверки среды выполнения, чтобы гарантировать, что приложение использует более новые API только на тех устройствах, которые достаточно актуальны для их поддержки. In other words, your code must include explicit runtime checks to ensure that your app uses newer APIs only on devices that are recent enough to support them. Проверка среды выполнения для версий Androidдалее в этом руководство объясняет, как добавить эти проверки среды выполнения в код. Runtime Checks for Android Versions, later in this guide, explains how to add these runtime checks to your code.

Чтобы получить доступ к параметру минимальной версии Android в Visual Studio, откройте свойства проекта в Обозреватель решений и выберите страницу манифеста Android . To access the Minimum Android version setting in Visual Studio, open the project properties in Solution Explorer and select the Android Manifest page. В раскрывающемся меню в разделе Минимальная версия Android можно выбрать минимальную версию Android для приложения: In the drop-down menu under Minimum Android version you can select the Minimum Android version for your application:

Если выбрать параметр использовать компиляцию с использованием версии пакета SDK, минимальная версия Android будет совпадать с целевой платформой. If you select Use Compile using SDK version, the Minimum Android version will be the same as the Target Framework setting.

Чтобы получить доступ к минимальной версии Android в Visual Studio для Mac, щелкните правой кнопкой мыши имя проекта и выберите пункт Параметры. Откроется диалоговое окно Параметры проекта . To access the Minimum Android version in Visual Studio for Mac, right-click the project name and select Options; this opens the Project Options dialog. Перейдите к сборке > приложение Android. Navigate to Build > Android Application. С помощью раскрывающегося меню справа от минимальной версии Androidможно задать минимальную версию Android для приложения: Using the drop-down menu to the right of Minimum Android version, you can set the Minimum Android version for your application:

При выборе параметра автоматически – использовать целевую версию .NET Frameworkминимальная версия Android будет совпадать с целевой платформой. If you select Automatic – use target framework version, the Minimum Android version will be the same as the Target Framework setting.

Целевая версия Android Target Android Version

Целевая версия Android (также известная как targetSdkVersion ) — это уровень API устройства Android, на котором должно выполняться приложение. The Target Android Version (also known as targetSdkVersion ) is the API level of the Android device where the app expects to run. Android использует этот параметр, чтобы определить, следует ли включить любое поведение совместимости – это гарантирует, что приложение продолжит работать так, как вы планируете. Android uses this setting to determine whether to enable any compatibility behaviors – this ensures that your app continues to work the way you expect. Android использует параметр целевой версии Android приложения, чтобы определить, какие изменения поведения можно применить к приложению без его нарушения (это то, как Android обеспечивает прямую совместимость). Android uses the Target Android version setting of your app to figure out which behavior changes can be applied to your app without breaking it (this is how Android provides forward compatibility).

Целевая платформа и Целевая версия Android с очень похожими именами не совпадают. The Target Framework and the Target Android version, while having very similar names, are not the same thing. Параметр целевой платформы передает сведения о целевом уровне API в Xamarin. Android для использования во время компиляции, а Целевая версия Android передает сведения о ЦЕЛЕВом интерфейсе API в Android для использования во время выполнения (если приложение установлен и работает на устройстве). The Target Framework setting communicates target API level information to Xamarin.Android for use at compile time, while the Target Android version communicates target API level information to Android for use at run time (when the app is installed and running on a device).

Чтобы получить доступ к этому параметру в Visual Studio, откройте свойства проекта в Обозреватель решений и выберите страницу манифеста Android . To access this setting in Visual Studio, open the project properties in Solution Explorer and select the Android Manifest page. В раскрывающемся меню в разделе Целевая версия Android можно выбрать целевую версию Android для приложения: In the drop-down menu under Target Android version you can select the Target Android version for your application:

Рекомендуется явно указать в качестве целевой версии Android последнюю версию Android, используемую для тестирования приложения. We recommend that you explicitly set the Target Android version to the latest version of Android that you use to test your app. В идеале для него следует установить последнюю версию пакет SDK для Android – это позволяет использовать новые интерфейсы API до начала работы с изменениями поведения. Ideally, it should be set to the latest Android SDK version – this allows you to use new APIs prior to working through the behavior changes. Для большинства разработчиков не рекомендуется задавать в качестве целевой версии Android Использование функции Compile с использованием версии пакета SDK. For most developers, we do not recommend setting the Target Android version to Use Compile using SDK version.

Чтобы получить доступ к этому параметру в Visual Studio для Mac, щелкните правой кнопкой мыши имя проекта и выберите пункт Параметры. Откроется диалоговое окно Параметры проекта . To access this setting in Visual Studio for Mac, right-click the project name and select Options; this opens the Project Options dialog. Перейдите к сборке > приложение Android. Navigate to Build > Android Application. С помощью раскрывающегося меню справа от целевой версии Androidможно задать целевую версию Android для приложения: Using the drop-down menu to the right of Target Android version, you can set the Target Android version for your application:

Рекомендуется явно указать в качестве целевой версии Android последнюю версию Android, используемую для тестирования приложения. We recommend that you explicitly set the Target Android version to the latest version of Android that you use to test your app. В идеале следует установить последнюю доступную версию пакет SDK для Android – это позволяет использовать новые интерфейсы API до начала работы с изменениями поведения. Ideally, it should be set to the latest available Android SDK version – this allows you to use new APIs prior to working through the behavior changes. Для большинства разработчиков не рекомендуется устанавливать целевую версию Android для автоматического использования целевой версии .NET Framework. For most developers, we do not recommend setting the Target Android version to Automatic — use target framework version.

В общем случае целевая версия Android должна быть ограничена минимальной версией Android и целевой платформой. In general, the Target Android Version should be bounded by the Minimum Android Version and the Target Framework. Это означает следующее: That is:

Минимальная версия Andro > Minimum Andro >

Дополнительные сведения об уровнях пакета SDK см. в документации разработчика Android с помощью пакета SDK . For more information about SDK levels, see the Android Developer uses-sdk documentation.

Проверки среды выполнения для версий Android Runtime checks for Android versions

После выпуска каждой новой версии Android API платформы обновляется для предоставления новых или замещающих функций. As each new version of Android is released, the framework API is updated to provide new or replacement functionality. За некоторыми исключениями, функциональные возможности API из предыдущих версий Android переносятся в более новые версии Android без изменений. With few exceptions, API functionality from earlier Android versions is carried forward into newer Android versions without modifications. В результате, если приложение работает на определенном уровне API Android, оно, как правило, будет работать на более позднем уровне API Android без изменений. As a result, if your app runs on a particular Android API level, it will typically be able to run on a later Android API level without modifications. Но что делать, если вы также хотите запустить приложение в более ранних версиях Android? But what if you also want to run your app on earlier versions of Android?

При выборе минимальной версии Android, которая ниже целевой платформы, некоторые API могут быть недоступны приложению во время выполнения. If you select a Minimum Android version that is lower than your Target Framework setting, some APIs may not be available to your app at runtime. Однако приложение по-прежнему может работать на более раннем устройстве, но с ограниченной функциональностью. However, your app can still run on an earlier device, but with reduced functionality. Для каждого API, который недоступен на платформах Android, соответствующих параметру минимальной версии Android, код должен явно проверить значение свойства Android.OS.Build.VERSION.SdkInt , чтобы определить уровень API платформы, на которой работает приложение. For each API that is not available on Android platforms corresponding to your Minimum Android version setting, your code must explicitly check the value of the Android.OS.Build.VERSION.SdkInt property to determine the API level of the platform the app is running on. Если уровень API меньше, чем минимальная версия Android, поддерживающая API, которую нужно вызвать, то код должен найти способ правильной работы без выполнения этого вызова API. If the API level is lower than the Minimum Android version that supports the API you want to call, then your code has to find a way to function properly without making this API call.

Например, предположим, что мы хотим использовать метод нотификатионбуилдер. сеткатегори для категоризации уведомлений при работе в программной интерфейсной системе Android 5,0 (и более поздних версиях), но мы по-прежнему хотим, чтобы наше приложение выполнялось в более ранних версиях Android, например Android 4,1 Jelly Bean (где SetCategory недоступно). For example, let’s suppose that we want to use the NotificationBuilder.SetCategory method to categorize a notification when running on Android 5.0 Lollipop (and later), but we still want our app to run on earlier versions of Android such as Android 4.1 Jelly Bean (where SetCategory is not available). Ссылка на таблицу версий Android в начале этого руководством, мы видим, что код версии сборки для Android 5,0 без описания операций Android.OS.BuildVersionCodes.Lollipop . Referring to the Android version table at the beginning of this guide, we see that the build version code for Android 5.0 Lollipop is Android.OS.BuildVersionCodes.Lollipop . Для поддержки более старых версий Android, когда SetCategory недоступна, наш код может определить уровень API во время выполнения и условно вызвать метод SetCategory только в том случае, если уровень API больше или равен коду версии сборки без описания операций: To support older versions of Android where SetCategory is not available, our code can detect the API level at runtime and conditionally call SetCategory only when the API level is greater than or equal to the Lollipop build version code:

В этом примере для нашей целевой платформы приложения задано значение android 5,0 (API уровня 21) , а для минимальной версии Android — Android 4,1 (уровень API 16) . In this example, our app’s Target Framework is set to Android 5.0 (API Level 21) and its Minimum Android version is set to Android 4.1 (API Level 16). Поскольку SetCategory доступен на уровне API Android.OS.BuildVersionCodes.Lollipop и более поздних версий, этот пример кода будет вызывать SetCategory только тогда, когда он действительно доступен – он не будет пытаться вызывать SetCategory , если уровень API равен 16. , 17, 18, 19 или 20. Because SetCategory is available in API level Android.OS.BuildVersionCodes.Lollipop and later, this example code will call SetCategory only when it is actually available – it will not attempt to call SetCategory when the API level is 16, 17, 18, 19, or 20. Эта функция в предыдущих версиях Android сокращается только до того экстента, в котором уведомления не сортируются должным образом (так как они не классифицируются по типу), но уведомления по-прежнему публикуются для оповещения пользователя. The functionality is reduced on these earlier Android versions only to the extent that notifications are not sorted properly (because they are not categorized by type), yet the notifications are still published to alert the user. Наше приложение по-прежнему работает, но его функциональные возможности немного уменьшаются. Our app still works, but its functionality is slightly diminished.

Как правило, проверка версии сборки помогает вашему коду принимать во время выполнения действия по сравнению со старым способом. In general, the build version check helps your code decide at runtime between doing something the new way versus the old way. Пример: For example:

Нет быстрого и простого правила, объясняющих, как сократить или изменить функциональность приложения при запуске в более старых версиях Android, в которых отсутствует один или несколько API-интерфейсов. There’s no fast and simple rule that explains how to reduce or modify your app’s functionality when it runs on older Android versions that are lacking one or more APIs. В некоторых случаях (например, в приведенном выше примере SetCategory ) достаточно опустить вызов API, если он недоступен. In some cases (such as in the SetCategory example above), it’s sufficient to omit the API call when it’s not available. Однако в других случаях может потребоваться реализовать альтернативную функциональность для случаев, когда Android.OS.Build.VERSION.SdkInt обнаруживается меньше уровня API, необходимого приложению для обеспечения его оптимального взаимодействия. However, in other cases, you may need to implement alternate functionality for when Android.OS.Build.VERSION.SdkInt is detected to be less than the API level that your app needs to present its optimum experience.

Уровни API и библиотеки API levels and libraries

При создании проекта библиотеки Xamarin. Android (например, библиотеки классов или библиотеки привязок) можно настроить только параметр целевой платформы – минимальная версия Android и параметры целевой версии Android недоступны. When you create a Xamarin.Android library project (such as a class library or a bindings library), you can configure only the Target Framework setting – the Minimum Android version and the Target Android version settings are not available. Это связано с тем, что отсутствует страница манифеста Android : That is because there is no Android Manifest page:

При создании проекта библиотеки Xamarin. Android нет страницы приложения Android , на которой можно настроить минимальную версию Android и целевую версию Android – минимальная версия Android и параметры целевой версии Android не имеющ. When you create a Xamarin.Android library project, there is no Android Application page where you can configure the Minimum Android version and the Target Android version – the Minimum Android version and Target Android version settings are not available. Это связано с тем, что отсутствует страница сборки > приложение Android : That is because there is no Build > Android Application page:

Параметры минимальной версии Android и целевой версии Android недоступны, так как итоговая библиотека не является автономным приложением – библиотека может быть запущена в любой версии Android в зависимости от приложения, с которым оно упаковано. The Minimum Android version and Target Android version settings are not available because the resulting library is not a stand-alone app – the library could be run on any Android version, depending on the app that it is packaged with. Можно указать способ компиляциибиблиотеки, но нельзя предсказать, на каком уровне API платформы будет выполняться библиотека. You can specify how the library is to be compiled, but you can’t predict which platform API level the library will be run on. Учитывая это, при использовании или создании библиотек следует соблюдать следующие рекомендации. With this in mind, the following best practices should be observed when consuming or creating libraries:

При использовании библиотеки Android – если в приложении используется библиотека Android, убедитесь, что параметру целевой платформы приложения присвоено значение уровня API, которое не меньше максимального значения параметра целевой платформы библиотеки. When consuming an Android library – If you are consuming an Android library in your application, be sure to set your app’s Target Framework setting to an API level that is at least as high as the Target Framework setting of the library.

При создании библиотеки Android – если вы создаете библиотеку Android для использования другими приложениями, убедитесь, что для параметра целевой платформы задан минимальный уровень API, необходимый для компиляции. When creating an Android library – If you are creating an Android library for use by other applications, be sure to set its Target Framework setting to the minimum API level that it needs in order to compile.


Эти рекомендации рекомендуется использовать для предотвращения ситуации, когда библиотека пытается вызвать API, который недоступен во время выполнения (что может привести к сбою приложения). These best practices are recommended to help prevent the situation where a library attempts to call an API that is not available at runtime (which can cause the app to crash). Если вы разработчик библиотеки, вам следует ограничить использование вызовов API небольшим и хорошо установленным подмножеством общей контактной зоны API. If you are a library developer, you should strive to restrict your usage of API calls to a small and well-established subset of the total API surface area. Это гарантирует, что библиотеку можно будет использовать в более широком диапазоне версий Android. Doing so helps to ensure that your library can be used safely across a wider range of Android versions.

Api для связи сайта с andro >15.01.2020, 06:34. Просмотров 626. Ответов 2

15.01.2020, 06:34

MySQL для работы с android-приложением
Добрый вечер! Может я задам глупый вопрос или повторюсь, но уж простите, в этом деле новичок и.

Как подключить api сайта к приложению Android?
Имеется api вида include (‘engine/api/api.class.php’). Как мне подключить его в Eclipse и как в.

Нужно ли уходить с API 22 для работы под android 6
Что плохого в том, что моё приложение не оптимизировано под шестёрку? Я пока увидел плюс в том.

Мобильный клиент интернет магазина для Android API
Здравствуйте, Сразу скажу что ранее подобных API не создавал, поэтому не очень ориентируюсь в.

В какой папке сохраняются API для Android studio ?
После каждой установки Апи(download api) я замечаю как сразу на несколько гигов уменьшается места.

Программно получить уровень API Android на устройстве?

Как узнать, какой уровень API используется моим устройством?

Версия прошивки — 1.6. Означает ли это, что он использует API Level 4?

Уровень API можно получить программно с помощью системной константы ( Build.VERSION.SDK_INT ). Например, вы можете запустить какой-то фрагмент кода, для которого требуется более новый API, следующим образом (он будет выполнен, если текущий уровень API устройства не меньше 4)

Чтобы получить видимую для пользователя версию Android, используйте:

Для API Level> = 4 вы можете использовать Build.VERSION.SDK_INT

Usage

Чтобы получить текущее API вашего устройства:

КЛАДР

Описание для КЛАДР

КЛАДР Tags

By adding tag words that describe for Games&Apps, you’re helping to make these Games and Apps be more discoverable by other APKPure users.

Additional Information

Категория:

Последняя версия:

Дата публикации:

Получить:

Требования:

Жаловаться:

Обновлено: 2015-12-27

Требуется Android: Android 4.0.3+ (Ice Cream Sandwich MR1, API 15)

Подпись: cde503ff9955994158d97ce374ae455abd8ae2b1

Screen DPI: 160-640dpi

Architecture: universal

Файл SHA1-хэша: a5d24d98b9e55f5c4cf21120513c9c27c969f20b

Цукерберг рекомендует:  40 лет с Apple
Понравилась статья? Поделиться с друзьями:
Все языки программирования для начинающих